ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
Revision: 1.61
Committed: Thu Aug 30 07:13:17 2007 UTC (16 years, 8 months ago) by root
Branch: MAIN
Changes since 1.60: +9 -1 lines
Log Message:
make meta entries for resoruce files mandatory, 'saves' 11mb...

File Contents

# Content
1 #!@PERL@
2
3 use strict;
4
5 my $prefix = "@prefix@";
6 my $exec_prefix = "@exec_prefix@";
7 my $datarootdir = "@datarootdir@";
8 my $DATADIR = "@datadir@/@PACKAGE@";
9
10 my $CONVERT = "@CONVERT@";
11 #my $IDENTIFY = "@IDENTIFY@";
12 my $OPTIPNG = "@OPTIPNG@";
13 my $RSYNC = "@RSYNC@";
14 my $PNGNQ = "@PNGNQ@";
15
16 use Getopt::Long;
17 use Coro::Event;
18 use AnyEvent;
19 use IO::AIO ();
20 use File::Temp;
21 use Crossfire;
22 use Coro;
23 use Coro::AIO;
24 use Coro::Util;
25 use POSIX ();
26 use Carp;
27 use Coro::Channel;
28 use Coro::Storable; $Storable::canonical = 1;
29
30 $SIG{QUIT} = sub { Carp::cluck "QUIT" };
31
32 sub usage {
33 warn <<EOF;
34 Usage: cfutil [-v] [-q] [--force] [--cache]
35 [--install-arch path]
36 [--install-maps maps]
37 [--print-statedir]
38 [--print-confdir]
39 [--print-datadir]
40 [--print-libdir]
41 [--print-bindir]
42 EOF
43 exit 1;
44 }
45
46 my $VERBOSE = 1;
47 my $CACHE = 0;
48 my $FORCE;
49 my $TMPDIR = "/tmp/cfutil$$~";
50 my $TMPFILE = "aaaa0";
51
52 our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66 );
67
68 END { system "rm", "-rf", $TMPDIR }
69
70 Event->signal (signal => "INT", cb => sub { exit 1 });
71 Event->signal (signal => "TERM", cb => sub { exit 1 });
72
73 mkdir $TMPDIR, 0700
74 or die "$TMPDIR: $!";
75
76 sub fork_sub(&) {
77 my ($cb) = @_;
78
79 if (my $pid = fork) {
80 my $current = $Coro::current;
81 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
82 Coro::schedule;
83 } else {
84 eval { $cb->() };
85 POSIX::_exit 0 unless $@;
86 warn $@;
87 POSIX::_exit 1;
88 }
89 }
90
91 sub inst_maps($) {
92 my (undef, $path) = @_;
93
94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
95
96 if (!-f "$path/regions") {
97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
98 exit 1 unless $FORCE;
99 }
100
101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
102 and die "map installation failed.\n";
103
104 print "maps installed successfully.\n";
105 }
106
107 {
108 our %ANIMINFO;
109 our %FACEINFO;
110 our %RESOURCE;
111 our @ARC;
112 our %ARC;
113 our $TRS;
114 our $NFILE;
115 our $PATH;
116
117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
118
119 our $c_arc = new Coro::Channel;
120 our $c_trs = new Coro::Channel;
121 our $c_res = new Coro::Channel;
122
123 our @c_png;
124
125 sub commit_png($$$) {
126 my ($name, $data, $T) = @_;
127
128 $FACEINFO{$name}{"data$T"} = $data;
129 }
130
131 sub process_png {
132 while (@c_png) {
133 my ($path, $delete) = @{pop @c_png};
134
135 my $png;
136 aio_lstat $path;
137 my ($size, $mtime) = (stat _)[7,9];
138
139 if (0 > aio_load $path, $png) {
140 warn "$path: $!, skipping.\n";
141 next;
142 }
143
144 my $stem = $path;
145 my $T;
146
147 if ($stem =~ s/\.32x32\.png~?$//) {
148 $T = 32;
149 } elsif ($stem =~ s/\.64x64\.png~?$//) {
150 $T = 64;
151 } else {
152 warn "$path: weird filename, skipping.\n";
153 next;
154 }
155
156 # quickly extract width and height of the (necessarily PNG) image
157 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
158 warn "$path: not a recognized png file, skipping.\n";
159 next;
160 }
161
162 my ($w, $h) = unpack "NN", $1;
163
164 if ($w < $T || $h < $T) {
165 warn "$path: too small ($w $h), skipping.\n";
166 next;
167 }
168
169 if ($w % $T || $h % $T) {
170 warn "$path: weird png size ($w $h), skipping.\n";
171 next;
172 }
173
174 (my $base = $stem) =~ s/^.*\///;
175
176 my $fi = $FACEINFO{$base};
177 unless ($fi) {
178 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
179 #next;
180 }
181
182 my $arc = $fi->{arc} || { };
183
184 unless ($path =~ /~$/) {
185 # possibly enlarge
186 if (0 > aio_stat "$stem.64x64.png") {
187 my $other = "$stem.64x64.png~";
188
189 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
190 fork_sub {
191 my $CROP;
192 my $SRC = "png:\Q$path\E";
193
194 my $is_floor = $arc->{is_floor};
195 my $is_wall = 0;
196
197 my ($wall_pfx, $wall_dir, $wall_sfx);
198
199 if (
200 !$is_floor
201 && !$arc->{alive}
202 && $arc->{move_block} eq "all"
203 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
204 ) {
205 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
206
207 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
208 $is_wall = 1;
209 }
210 }
211
212 if ($is_wall || $is_floor) {
213 # add a 4px border and add other images around it
214 $CROP = "-shave 8x8 +repage";
215
216 $w += 8;
217 $h += 8;
218
219 $SRC = "-size ${w}x${h} xc:transparent";
220 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
221
222 # 8 surrounding images
223 for (
224 # x y b r0 r1
225 [-1, -1, 0, 6],
226 [ 0, -1, 1, 10, 14],
227 [+1, -1, 0, 12],
228
229 [-1, 0, 8, 5, 7],
230 #
231 [+1, 0, 2, 5, 13],
232
233 [-1, +1, 0, 3],
234 [ 0, +1, 4, 10, 11],
235 [+1, +1, 0, 9],
236 ) {
237 my ($x, $y, $d, $r0, $r1) = @$_;
238
239 my $tile = $is_floor ? $path
240 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
241 : die;
242
243 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
244 "\Q$tile",
245 $x * ($w - 8) + 4,
246 $y * ($h - 8) + 4;
247 }
248 }
249
250 system "convert -depth 8 $SRC rgba:-"
251 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
252 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
253 and die "convert/cfhq2xa pipeline error: status $? ($!)";
254 system $OPTIPNG, "-i0", "-q", "$other~";
255 die "$other~ has zero size, aborting." unless -s "$other~";
256 rename "$other~", $other;
257 };
258 }
259
260 push @c_png, [$other, !$CACHE];
261 }
262
263 # possibly scale down
264 if (0 > aio_stat "$stem.32x32.png") {
265 my $other = "$stem.32x32.png~";
266
267 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
268 fork_sub {
269 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
270 system $OPTIPNG, "-i0", "-q", "$other~";
271
272 # reduce smoothfaces >10000 bytes
273 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
274 my $ncolor = 256;
275 while () {
276 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
277 system $OPTIPNG, "-i0", "-q", "$other~~";
278 last if 10000 > -s "$other~~";
279 $ncolor = int $ncolor * 0.9;
280 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
281 }
282
283 printf "reduced %s from %d to %d bytes using %d colours.\n",
284 $other, -s "$other~", -s "$other~~", $ncolor
285 if $VERBOSE >= 2;
286 rename "$other~~", "$other~";
287 }
288
289 die "$other~ has zero size, aborting." unless -s "$other~";
290 rename "$other~", $other;
291 };
292 }
293
294 #warn "scaled down $path to $other\n";#d#
295 push @c_png, [$other, !$CACHE];
296 }
297 }
298
299 (my $face = $stem) =~ s/^.*\///;
300
301 # split all bigfaces, but avoid smoothfaces (*_S)
302 if (($w > $T || $h > $T) && $face !~ /_S\./) {
303 # split
304 my @tile;
305 for my $x (0 .. (int $w / $T) - 1) {
306 for my $y (0 .. (int $h / $T) - 1) {
307 my $file = "$path+$x+$y~";
308 aio_lstat $file;
309 push @tile, [$x, $y, $file, (stat _)[9]];
310 }
311 }
312
313 my $mtime = (lstat $path)[9];
314 my @todo = grep { $_->[3] <= $mtime } @tile;
315 if (@todo) {
316 fork_sub {
317 open my $convert, "|-", $CONVERT,
318 "png:-",
319 (map {
320 (
321 "(",
322 "+clone",
323 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
324 "+repage",
325 -quality => "00",
326 -write => "png32:$_->[2]~",
327 "+delete",
328 ")",
329 )
330 } @todo),
331 "null:";
332
333 binmode $convert;
334 print $convert $png;
335 close $convert;
336
337 # pass 2, optimise, and rename
338 for (@todo) {
339 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
340 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
341 rename "$_->[2]~", $_->[2];
342 }
343 };
344 }
345
346 for (@tile) {
347 my ($x, $y, $file) = @$_;
348 my $tile;
349
350 if (0 > aio_load $file, $tile) {
351 die "$path: unable to read tile +$x+$y, aborting.\n";
352 }
353 IO::AIO::aio_unlink $file unless $CACHE;
354 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
355 }
356 } else {
357 # use as-is (either small, use smooth)
358 commit_png $face, $png, $T;
359 }
360
361 aio_unlink $path if $delete;
362 }
363 }
364
365 sub process_arc {
366 while (my $job = $c_arc->get) {
367 my ($dir, $file) = @$job;
368
369 my $arc;
370 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
371
372 my $arc = read_arch "$dir/$file";
373 for my $o (values %$arc) {
374 push @ARC, $o;
375 for (my $m = $o; $m; $m = $m->{more}) {
376 $ARC{$m->{_name}} = $m;
377 }
378
379 $o->{editor_folder} = $dir;
380
381 my $visibility = delete $o->{visibility};
382 my $magicmap = delete $o->{magicmap};
383
384 # find upper left corner :/
385 # omg, this is sooo broken
386 my ($dx, $dy);
387 for (my $o = $o; $o; $o = $o->{more}) {
388 $dx = $o->{x} if $o->{x} < $dx;
389 $dy = $o->{y} if $o->{y} < $dy;
390 }
391
392 for (my $o = $o; $o; $o = $o->{more}) {
393 my $x = $o->{x} - $dx;
394 my $y = $o->{y} - $dy;
395
396 my $ext = $x|$y ? "+$x+$y" : "";
397
398 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
399
400 $visibility = delete $o->{visibility} if exists $o->{visibility};
401 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
402
403 my $anim = delete $o->{anim};
404
405 if ($anim) {
406 # possibly add $ext to the animation name to avoid
407 # the need to specify archnames for all parts
408 # of a multipart archetype.
409 $o->{animation} = "$o->{_name}";
410 my $facings = 1;
411 my @frames;
412
413 for (@$anim) {
414 if (/^facings\s+(\d+)/) {
415 $facings = $1*1;
416 } elsif (/^blank.x11$|^empty.x11$/) {
417 push @frames, $_;
418 } else {
419 push @frames, "$_$ext";
420 }
421 }
422
423 $ANIMINFO{$o->{animation}} = {
424 facings => $facings,
425 frames => \@frames,
426 };
427 }
428
429 for ($o->{face} || (), @{$anim || []}) {
430 next if /^facings\s/;
431
432 my $face = $_;
433 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
434
435 my $info = $FACEINFO{$face} ||= { };
436 $info->{arc} = $o;
437
438 next if $face =~ /^blank.x11$|^empty.x11$/;
439
440 $info->{visibility} = $visibility if defined $visibility;
441 $info->{magicmap} = $magicmap if defined $magicmap;
442 }
443
444 if (my $smooth = delete $o->{smoothface}) {
445 my %kv = split /\s+/, $smooth;
446 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
447 while (my ($face, $smooth) = each %kv) {
448 $FACEINFO{$smooth}{arc} = $o;
449
450 $FACEINFO{$face}{smooth} = $smooth;
451 $FACEINFO{$face}{smoothlevel} = $level;
452 }
453 }
454 }
455 }
456 }
457 }
458
459 sub process_trs {
460 while (my $job = $c_trs->get) {
461 my ($dir, $file) = @$job;
462 my $path = "$dir/$file";
463
464 my $trs;
465 if (0 > aio_load $path, $trs) {
466 warn "$path: $!, skipping.\n";
467 next;
468 }
469
470 $TRS .= $trs;
471 }
472 }
473
474 my %FILECACHE;
475
476 sub load_cached($;$) {
477 unless (exists $FILECACHE{$_[0]}) {
478 my $data;
479 if (0 < aio_load $_[0], $data) {
480 if ($_[1]) {
481 $data = eval { $_[1]->($data) };
482 warn "$_[0]: $@" if $@;
483 }
484 }
485
486 $FILECACHE{$_[0]} = $data;
487 }
488
489 $FILECACHE{$_[0]}
490 }
491
492 sub process_res {
493 while (my $job = $c_res->get) {
494 my ($dir, $file, $type) = @$job;
495
496 my $data;
497 aio_load "$dir/$file", $data;
498
499
500 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
501
502 utf8::decode $dir;
503 utf8::decode $file;
504
505 # a meta file for resources is now mandatory
506 unless (exists $meta->{$file}) {
507 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
508 next;
509 }
510
511 $meta = {
512 %{ $meta->{"" } || {} },
513 %{ $meta->{$file} || {} },
514 };
515
516 if ($meta->{license} =~ s/^#//) {
517 $meta->{license} = ({
518 "pd" => "Public Domain",
519 "gpl" => "GNU General Public License, version 3.0 or any later",
520 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
521 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
522 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
523 })->{$meta->{license}}
524 || warn "$dir/$file: license tag '$meta->{license}' not found.";
525 }
526
527 $file =~ s/\.res$//;
528 $file =~ s/\.(ogg|wav|jpg|png)$//;
529
530 substr $dir, 0, 1 + length $PATH, "";
531
532 $RESOURCE{"$dir/$file"} = {
533 type => (delete $meta->{type}) || $type,
534 data => $data,
535 %$meta ? (meta => $meta) : (),
536 };
537 }
538 }
539
540 sub find_files;
541 sub find_files {
542 my ($path) = @_;
543
544 IO::AIO::aioreq_pri 4;
545 IO::AIO::aio_scandir $path, 4, sub {
546 my ($dirs, $nondirs) = @_;
547
548 find_files "$path/$_"
549 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
550
551 my $dir = $path;
552 substr $dir, 0, 1 + length $PATH, "";
553
554 for my $file (@$nondirs) {
555 if ($dir =~ /^music(?:\/|$)/) {
556 $c_res->put ([$path, $file, 3]) # FT_MUSIC
557 if $file =~ /\.(ogg)$/;
558
559 } elsif ($dir =~ /^sound(?:\/|$)/) {
560 $c_res->put ([$path, $file, 5]) # FT_SOUND
561 if $file =~ /\.(wav|ogg)$/;
562
563 } elsif ($dir =~ /^res(?:\/|$)/) {
564 $c_res->put ([$path, $file, 0]) # FT_FACE
565 if $file =~ /\.(jpg|png)$/;
566 $c_res->put ([$path, $file, 7]) # FT_RSRC
567 if $file =~ /\.(res)$/;
568
569 } elsif ($file =~ /\.png$/) {
570 push @c_png, ["$path/$file", 0];
571
572 } elsif ($file =~ /\.trs$/) {
573 $c_trs->put ([$path, $file]);
574
575 } elsif ($file =~ /\.arc$/) {
576 $c_arc->put ([$path, $file]);
577
578 } else {
579 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
580 }
581 }
582 };
583 }
584
585 sub inst_arch($) {
586 my (undef, $path) = @_;
587
588 $PATH = $path;
589
590 print "\n",
591 "Installing '$path' to '$DATADIR'\n",
592 "\n",
593 "This can take a long time if you run this\n",
594 "for the first time or do not use --cache.\n",
595 "\n",
596 "Unless you run verbosely, all following warning\n",
597 "or error messages indicate serious problems.\n",
598 "\n";
599
600 if (!-d "$path/treasures") {
601 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
602 exit 1 unless $FORCE;
603 }
604
605 print "scanning files...\n" if $VERBOSE;
606
607 find_files $path;
608
609 my @a_arc = map +(async \&process_arc), 1..2;
610 my @a_res = map +(async \&process_res), 1..2;
611 my @a_trs = map +(async \&process_trs), 1..2;
612
613 IO::AIO::flush;
614
615 $c_res->put (undef) for @a_res;
616 $c_arc->put (undef) for @a_arc;
617 $c_trs->put (undef) for @a_trs;
618
619 print "start file scan, arc, res processing...\n" if $VERBOSE;
620
621 $_->join for @a_arc; # need to parse all archetypes before png processing
622
623 print "end arc, start png processing...\n" if $VERBOSE;
624
625 # four png crunchers work fine for my 2x smp machine
626 my @a_png = map +(async \&process_png), 1..4;
627
628 $_->join for (@a_trs, @a_res, @a_png);
629
630 print "scanning done, processing results...\n" if $VERBOSE;
631 {
632 # remove path prefix from editor_folder
633 substr $_->{editor_folder}, 0, 1 + length $path, ""
634 for values %ARC;
635
636 print "resolving inheritance tree...\n" if $VERBOSE;
637 # resolve inherit
638 while () {
639 my $progress;
640 my $loop;
641
642 for my $o (values %ARC) {
643 if (my $other = $o->{inherit}) {
644 if (my $s = $ARC{$other}) {
645 if ($s->{inherit}) {
646 $loop = $s;
647 } else {
648 delete $o->{inherit};
649 my %s = %$s;
650 delete @s{qw(_name more name name_pl)};
651 %$o = ( %s, %$o );
652 ++$progress;
653 }
654 } else {
655 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
656 delete $ARC{$o->{_name}};
657 }
658 }
659 }
660
661 unless ($progress) {
662 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
663 if $loop;
664
665 last;
666 }
667 }
668
669 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
670 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
671
672 print "writing archetypes...\n" if $VERBOSE;
673 open my $fh, ">:utf8", "$DATADIR/archetypes~"
674 or die "$DATADIR/archetypes~: $!";
675 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
676 }
677
678 {
679 print "writing treasures...\n" if $VERBOSE;
680 open my $fh, ">:utf8", "$DATADIR/treasures~"
681 or die "$DATADIR/treasures~: $!";
682 print $fh $TRS;
683 }
684
685 {
686 print "processing facedata...\n" if $VERBOSE;
687 while (my ($k, $v) = each %FACEINFO) {
688 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
689 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
690
691 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
692 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
693
694 if (my $magicmap = $v->{magicmap}) {
695 $magicmap =~ y/A-Z_\-/a-z/d;
696 $v->{magicmap} = $COLOR{$magicmap};
697 }
698
699 delete $v->{arc};
700 }
701
702 print "writing facedata...\n" if $VERBOSE;
703 open my $fh, ">:perlio", "$DATADIR/facedata~"
704 or die "$DATADIR/facedata~: $!";
705
706 print $fh freeze {
707 version => 2,
708 faceinfo => \%FACEINFO,
709 animinfo => \%ANIMINFO,
710 resource => \%RESOURCE,
711 };
712 }
713
714 print "committing files...\n" if $VERBOSE;
715
716 for (qw(archetypes facedata treasures)) {
717 chmod 0644, "$DATADIR/$_~";
718 rename "$DATADIR/$_~", "$DATADIR/$_"
719 or die "$DATADIR/$_: $!";
720 }
721
722 print "archetype data installed successfully.\n";
723 }
724 }
725
726 Getopt::Long::Configure ("bundling", "no_ignore_case");
727 GetOptions (
728 "verbose|v:+" => \$VERBOSE,
729 "cache" => \$CACHE,
730 "quiet|q" => sub { $VERBOSE = 0 },
731 "force" => sub { $FORCE = 1 },
732 "install-arch=s" => \&inst_arch,
733 "install-maps=s" => \&inst_maps,
734 "print-statedir" => sub { print "@pkgstatedir@\n" },
735 "print-datadir" => sub { print "$DATADIR\n" },
736 "print-confdir" => sub { print "@pkgconfdir@\n" },
737 "print-libdir" => sub { print "@libdir@/@PACKAGE@\n" },
738 "print-bindir" => sub { print "@bindir@/@PACKAGE@\n" },
739 ) or usage;
740